﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Syncfusion.Windows.Tools.Controls;
using System.ComponentModel;
using System.Windows.Threading;
using System.Timers;

namespace TreeViewDemo1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = this;
         }
        ObservableCollection<TreeviewItems> _MyModel;
        public ObservableCollection<TreeviewItems> MyModel
        {
            get
            {
                if (_MyModel == null)
                {
                    _MyModel = new MyItems();
                }
                return _MyModel;
            }
            set
            {
                MyModel = value;
            }
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            string CurrentButton = (sender as Button).Content.ToString() ;
            if (textBox1.Text != null)
            {
                int val1 = int.Parse(textBox1.Text.ToString());
                switch(CurrentButton)
                {
                   case "ExpandParticularNode":
                   MyModel[val1].IsExpandedNode = true;
                   break;
                   case "Shirnk ParticularNode":
                   MyModel[val1].IsExpandedNode = false ;
                   break;
                    case "Expand to Level":
                        for(int i=0;i<val1;i++)
                            MyModel[i].IsExpandedNode = true ;
                        break;
                   case "Collaps Visible":
                   MyModel[val1].IsVisibilityNode  = Visibility.Collapsed;
                   break;
                   case "Make Visible":
                        MyModel[val1].IsVisibilityNode = Visibility.Visible;
                        break;
                   case "ShirnkToLevel":
                        for(int i=0;i<val1;i++)
                            MyModel[i].IsExpandedNode = false;
                        break;
                   case "CollapseSubNode":
                        MyModel[val1].Child[int.Parse(textBox2.Text.ToString())].IsVisibilityNode = Visibility.Collapsed;
                        break;
                   case "MakeVisibleSubNode":
                        MyModel[val1].Child[int.Parse(textBox2.Text.ToString())].IsVisibilityNode = Visibility.Visible;
                        break;
                   
                }
            }
        }

        
    }

        public class TreeviewItems: INotifyPropertyChanged
        {   
            public string Header{get;set;}
            public ObservableCollection<TreeviewItems> Child { get; set; }
            private Visibility _IsVisibilityNode = Visibility.Visible  ;
            public Visibility IsVisibilityNode { get { return _IsVisibilityNode; } set { _IsVisibilityNode = value; OnPropertyChanged("IsVisibilityNode"); } }
            private bool _IsExpandedNode=false;
            public bool IsExpandedNode { get { return _IsExpandedNode; } set { _IsExpandedNode = value; OnPropertyChanged("IsExpandedNode"); } }
            #region INotifyPropertyChanged Members

            public event PropertyChangedEventHandler PropertyChanged;

            private void OnPropertyChanged(string name)
            {
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs(name));
                }
            }

            #endregion
        }


    public class MyItems:ObservableCollection<TreeviewItems>
    {
       public MyItems()
        {
            ObservableCollection<TreeviewItems> Root1 = new ObservableCollection<TreeviewItems>();
            ObservableCollection<TreeviewItems> Root2 = new ObservableCollection<TreeviewItems>();
            ObservableCollection<TreeviewItems> Root3 = new ObservableCollection<TreeviewItems>();
            ObservableCollection<TreeviewItems> Root4 = new ObservableCollection<TreeviewItems>();
            ObservableCollection<TreeviewItems> Root5 = new ObservableCollection<TreeviewItems>();

            Root1.Add(new TreeviewItems() { Header = "Item11" });
            Root1.Add(new TreeviewItems() { Header = "Item12" });
            Root1.Add(new TreeviewItems() { Header = "Item13" });
            Root2.Add(new TreeviewItems() { Header = "Item21" });
            Root2.Add(new TreeviewItems() { Header = "Item22" });
            Root3.Add(new TreeviewItems() { Header = "Item31" });
            Root3.Add(new TreeviewItems() { Header = "Item32" });
            Root4.Add(new TreeviewItems() { Header = "Item41" });
            Root4.Add(new TreeviewItems() { Header = "Item42" });
            Root5.Add(new TreeviewItems() { Header = "Item51" });
            Root5.Add(new TreeviewItems() { Header = "Item52" });
            Root5.Add(new TreeviewItems() { Header = "Item53" });
            
            this.Add(new TreeviewItems(){Header="Root1", Child=Root1});
            this.Add(new TreeviewItems() { Header = "Root2 " , Child = Root2 });
            this.Add(new TreeviewItems() { Header = "Root3 " , Child = Root3 });
            this.Add(new TreeviewItems() { Header = "Root4 " , Child = Root4 });
            this.Add(new TreeviewItems() { Header = "Root5 " , Child = Root5});
        }

       
       
    }


  
}
